<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="项目id" prop="dataId">
        <el-input v-model="formData.dataId" placeholder="请输入项目id" />
      </el-form-item>
      <el-form-item label="训练集比例" prop="train">
        <el-input v-model="formData.train" placeholder="请输入训练集比例" />
      </el-form-item>
      <el-form-item label="验证图像比例" prop="val">
        <el-input v-model="formData.val" placeholder="请输入验证图像比例" />
      </el-form-item>
      <el-form-item label="测试图像比例" prop="test">
        <el-input v-model="formData.test" placeholder="请输入测试图像比例" />
      </el-form-item>
      <el-form-item label="轮次" prop="round">
        <el-input v-model="formData.round" placeholder="请输入轮次" />
      </el-form-item>
      <el-form-item label="批次大小" prop="size">
        <el-input v-model="formData.size" placeholder="请输入批次大小" />
      </el-form-item>
      <el-form-item label="图片大小（正方向，大于这个值进行缩放，小于这个值进行放大，不是正方形将图片周围涂黑）" prop="imageSize">
        <el-input v-model="formData.imageSize" placeholder="请输入图片大小（正方向，大于这个值进行缩放，小于这个值进行放大，不是正方形将图片周围涂黑）" />
      </el-form-item>
      <el-form-item label="预选训练模型" prop="modelPath">
        <el-input v-model="formData.modelPath" placeholder="请输入预选训练模型" />
      </el-form-item>
      <el-form-item label="训练图片路径" prop="path">
        <el-input v-model="formData.path" placeholder="请输入训练图片路径" />
      </el-form-item>
      <el-form-item label="类型，使用哪个gpu" prop="trainType">
        <el-select v-model="formData.trainType" placeholder="请选择类型，使用哪个gpu">
          <el-option label="请选择字典生成" value="" />
        </el-select>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { TrainApi, TrainVO } from '@/api/annotation/train'

/** 训练 表单 */
defineOptions({ name: 'TrainForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  dataId: undefined,
  train: undefined,
  val: undefined,
  test: undefined,
  round: undefined,
  size: undefined,
  imageSize: undefined,
  modelPath: undefined,
  path: undefined,
  trainType: undefined,
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await TrainApi.getTrain(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as TrainVO
    if (formType.value === 'create') {
      await TrainApi.createTrain(data)
      message.success(t('common.createSuccess'))
    } else {
      await TrainApi.updateTrain(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    dataId: undefined,
    train: undefined,
    val: undefined,
    test: undefined,
    round: undefined,
    size: undefined,
    imageSize: undefined,
    modelPath: undefined,
    path: undefined,
    trainType: undefined,
  }
  formRef.value?.resetFields()
}
</script>